// Generated by gencpp from file teleop_msgs/RGParamsRequest.msg
// DO NOT EDIT!


#ifndef TELEOP_MSGS_MESSAGE_RGPARAMSREQUEST_H
#define TELEOP_MSGS_MESSAGE_RGPARAMSREQUEST_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace teleop_msgs
{
template <class ContainerAllocator>
struct RGParamsRequest_
{
  typedef RGParamsRequest_<ContainerAllocator> Type;

  RGParamsRequest_()
    : a(0.0)
    , b(0.0)
    , c(0.0)
    , d_ac(0.0)
    , K_ac()
    , B_ac()
    , d_ac_obs(0.0)
    , K_ac_obs()
    , B_ac_obs()
    , ac_type()  {
    }
  RGParamsRequest_(const ContainerAllocator& _alloc)
    : a(0.0)
    , b(0.0)
    , c(0.0)
    , d_ac(0.0)
    , K_ac(_alloc)
    , B_ac(_alloc)
    , d_ac_obs(0.0)
    , K_ac_obs(_alloc)
    , B_ac_obs(_alloc)
    , ac_type(_alloc)  {
  (void)_alloc;
    }



   typedef double _a_type;
  _a_type a;

   typedef double _b_type;
  _b_type b;

   typedef double _c_type;
  _c_type c;

   typedef double _d_ac_type;
  _d_ac_type d_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _K_ac_type;
  _K_ac_type K_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _B_ac_type;
  _B_ac_type B_ac;

   typedef double _d_ac_obs_type;
  _d_ac_obs_type d_ac_obs;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _K_ac_obs_type;
  _K_ac_obs_type K_ac_obs;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _B_ac_obs_type;
  _B_ac_obs_type B_ac_obs;

   typedef std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> _ac_type_type;
  _ac_type_type ac_type;





  typedef boost::shared_ptr< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> const> ConstPtr;

}; // struct RGParamsRequest_

typedef ::teleop_msgs::RGParamsRequest_<std::allocator<void> > RGParamsRequest;

typedef boost::shared_ptr< ::teleop_msgs::RGParamsRequest > RGParamsRequestPtr;
typedef boost::shared_ptr< ::teleop_msgs::RGParamsRequest const> RGParamsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::teleop_msgs::RGParamsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::teleop_msgs::RGParamsRequest_<ContainerAllocator1> & lhs, const ::teleop_msgs::RGParamsRequest_<ContainerAllocator2> & rhs)
{
  return lhs.a == rhs.a &&
    lhs.b == rhs.b &&
    lhs.c == rhs.c &&
    lhs.d_ac == rhs.d_ac &&
    lhs.K_ac == rhs.K_ac &&
    lhs.B_ac == rhs.B_ac &&
    lhs.d_ac_obs == rhs.d_ac_obs &&
    lhs.K_ac_obs == rhs.K_ac_obs &&
    lhs.B_ac_obs == rhs.B_ac_obs &&
    lhs.ac_type == rhs.ac_type;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::teleop_msgs::RGParamsRequest_<ContainerAllocator1> & lhs, const ::teleop_msgs::RGParamsRequest_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace teleop_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "4f3d278473d74edb9e80f5f56c06580b";
  }

  static const char* value(const ::teleop_msgs::RGParamsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x4f3d278473d74edbULL;
  static const uint64_t static_value2 = 0x9e80f5f56c06580bULL;
};

template<class ContainerAllocator>
struct DataType< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "teleop_msgs/RGParamsRequest";
  }

  static const char* value(const ::teleop_msgs::RGParamsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 a\n"
"float64 b\n"
"float64 c\n"
"float64 d_ac\n"
"float64[] K_ac\n"
"float64[] B_ac\n"
"float64 d_ac_obs\n"
"float64[] K_ac_obs\n"
"float64[] B_ac_obs\n"
"string ac_type\n"
;
  }

  static const char* value(const ::teleop_msgs::RGParamsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.a);
      stream.next(m.b);
      stream.next(m.c);
      stream.next(m.d_ac);
      stream.next(m.K_ac);
      stream.next(m.B_ac);
      stream.next(m.d_ac_obs);
      stream.next(m.K_ac_obs);
      stream.next(m.B_ac_obs);
      stream.next(m.ac_type);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct RGParamsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::teleop_msgs::RGParamsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::teleop_msgs::RGParamsRequest_<ContainerAllocator>& v)
  {
    s << indent << "a: ";
    Printer<double>::stream(s, indent + "  ", v.a);
    s << indent << "b: ";
    Printer<double>::stream(s, indent + "  ", v.b);
    s << indent << "c: ";
    Printer<double>::stream(s, indent + "  ", v.c);
    s << indent << "d_ac: ";
    Printer<double>::stream(s, indent + "  ", v.d_ac);
    s << indent << "K_ac[]" << std::endl;
    for (size_t i = 0; i < v.K_ac.size(); ++i)
    {
      s << indent << "  K_ac[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.K_ac[i]);
    }
    s << indent << "B_ac[]" << std::endl;
    for (size_t i = 0; i < v.B_ac.size(); ++i)
    {
      s << indent << "  B_ac[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.B_ac[i]);
    }
    s << indent << "d_ac_obs: ";
    Printer<double>::stream(s, indent + "  ", v.d_ac_obs);
    s << indent << "K_ac_obs[]" << std::endl;
    for (size_t i = 0; i < v.K_ac_obs.size(); ++i)
    {
      s << indent << "  K_ac_obs[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.K_ac_obs[i]);
    }
    s << indent << "B_ac_obs[]" << std::endl;
    for (size_t i = 0; i < v.B_ac_obs.size(); ++i)
    {
      s << indent << "  B_ac_obs[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.B_ac_obs[i]);
    }
    s << indent << "ac_type: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>::stream(s, indent + "  ", v.ac_type);
  }
};

} // namespace message_operations
} // namespace ros

#endif // TELEOP_MSGS_MESSAGE_RGPARAMSREQUEST_H
